<?php
/**
 * Clase Base FN para BaseCrCierrehipotecaCFN
 *
 * @package    
 * @subpackage BaseCrCierrehipotecaCFN
 * @author     Willy
 * @version    SVN:: BaseCrCierrehipotecaCFN.class.php,v 1.1 2013-02-06 11:52:07 william.taype Exp $
 */
class BaseCrCierrehipotecaCFN extends CrCierrehipotecaCBN
{
  private static $fieldNames = array (
    'Idsucursal'=>'idsucursal', 'Fecha'=>'fecha', 'Nombresucursal'=>'nombresucursal', 'Nombreadministrador'=>'nombreadministrador', 'Ingresototal'=>'ingresototal', 'Salidatotal'=>'salidatotal', 'Saldototal'=>'saldototal', 'Observacion'=>'observacion', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro', 'Idcolaborador'=>'idcolaborador'  
  );

  public function select($groupby ='')
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, fecha, nombresucursal, nombreadministrador, moneda,ingresototal,ingresototalga,ingresototaldeposito, salidatotal, saldototal, observacion, fecharegistro, usuarioregistro, idcolaborador FROM cr_cierrehipoteca_c WHERE 1 ".$where." ".$groupby." ".$orden."   LIMIT ".$limitInf.",".$tamPag;
     
       $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, fecha, nombresucursal, nombreadministrador, ingresototal, ingresototalga, salidatotal, saldototal, observacion, fecharegistro, usuarioregistro, idcolaborador FROM cr_cierrehipoteca_c WHERE 1 ".$where;
       $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getMoneda()){ $where .= " AND moneda = '".$this->getMoneda()."'"; }
      if($this->getFechaFinal()){ $where .= " AND fecha <= '".$this->getFechaFinal()."'"; }
      if($this->getFechaInicial()){ $where .= " AND fecha >= '".$this->getFechaInicial()."'"; }
      if($this->getNombresucursal()){ $where .= " AND nombresucursal = '".$this->getNombresucursal()."'"; }
      if($this->getNombreadministrador()){ $where .= " AND nombreadministrador = '".$this->getNombreadministrador()."'"; }
      if($this->getIngresototal()){ $where .= " AND ingresototal = '".$this->getIngresototal()."'"; }
      if($this->getSalidatotal()){ $where .= " AND salidatotal = '".$this->getSalidatotal()."'"; }
      if($this->getSaldototal()){ $where .= " AND saldototal = '".$this->getSaldototal()."'"; }
      if($this->getObservacion()){ $where .= " AND observacion = '".$this->getObservacion()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idsucursal, fecha, nombresucursal, nombreadministrador, ingresototal, ingresototalga, moneda,salidatotal, saldototal, observacion, fecharegistro, usuarioregistro, idcolaborador FROM cr_cierrehipoteca_c WHERE 1 AND idsucursal='".$this->getIdsucursal()."' AND fecha='".$this->getFecha()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCierrehipotecaCFN = new BaseCrCierrehipotecaCFN();
    $o_BaseCrCierrehipotecaCFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseCrCierrehipotecaCFN->setFecha($o_propel->fecha);
    $o_BaseCrCierrehipotecaCFN->setMoneda($o_propel->moneda);
    $o_BaseCrCierrehipotecaCFN->setNombresucursal($o_propel->nombresucursal);
    $o_BaseCrCierrehipotecaCFN->setNombreadministrador($o_propel->nombreadministrador);
    $o_BaseCrCierrehipotecaCFN->setIngresototal($o_propel->ingresototal);
    $o_BaseCrCierrehipotecaCFN->setIngresototalga($o_propel->ingresototalga);
    $o_BaseCrCierrehipotecaCFN->setIngresototalDeposito($o_propel->ingresototaldeposito);
    $o_BaseCrCierrehipotecaCFN->setSalidatotal($o_propel->salidatotal);
    $o_BaseCrCierrehipotecaCFN->setSaldototal($o_propel->saldototal);
    $o_BaseCrCierrehipotecaCFN->setObservacion($o_propel->observacion);
    $o_BaseCrCierrehipotecaCFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseCrCierrehipotecaCFN->setUsuarioregistro($o_propel->usuarioregistro);
    $o_BaseCrCierrehipotecaCFN->setIdcolaborador($o_propel->idcolaborador);
    return $o_BaseCrCierrehipotecaCFN;
  }
}